Package org.apache.bcel.classfile

# Class BootstrapMethods

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.BootstrapMethods

All Implemented Interfaces:
  `Cloneable`, `Iterable<BootstrapMethod>`, `Node`

public class BootstrapMethods extends Attribute implements Iterable<BootstrapMethod>
This class represents a BootstrapMethods attribute.

Since:
  6.0
See Also:
  - The class File Format : The BootstrapMethods Attribute

- ## Field Summary

  ### Fields inherited from class org.apache.bcel.classfile.Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BootstrapMethods(int nameIndex, int length, BootstrapMethod[] bootstrapMethods, ConstantPool constantPool)`
  `BootstrapMethods(BootstrapMethods c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `BootstrapMethods`
  `copy(ConstantPool constantPool)`
  `final void`
  `dump(DataOutputStream file)`
  Dump bootstrap methods attribute to file stream in binary format.
  `final BootstrapMethod[]`
  `getBootstrapMethods()`
  `Iterator<BootstrapMethod>`
  `iterator()`
  `final void`
  `setBootstrapMethods(BootstrapMethod[] bootstrapMethods)`
  `final String`
  `toString()`

  ### Methods inherited from class org.apache.bcel.classfile.Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### BootstrapMethods

    public BootstrapMethods(BootstrapMethods c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.
    Parameters:
      `c` - Source to copy.

  - ### BootstrapMethods

    public BootstrapMethods(int nameIndex, int length, BootstrapMethod[] bootstrapMethods, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8
      `length` - Content length in bytes
      `bootstrapMethods` - array of bootstrap methods
      `constantPool` - Array of constants

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Description copied from class: `Attribute`
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object

  - ### copy

    public BootstrapMethods copy(ConstantPool constantPool)
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute

  - ### dump

    public final void dump(DataOutputStream file) throws IOException
    Dump bootstrap methods attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getBootstrapMethods

    public final BootstrapMethod[] getBootstrapMethods()
    Returns:
      array of bootstrap method "records"

  - ### iterator

    public Iterator<BootstrapMethod> iterator()
    Specified by:
      `iterator` in interface `Iterable<BootstrapMethod>`

  - ### setBootstrapMethods

    public final void setBootstrapMethods(BootstrapMethod[] bootstrapMethods)
    Parameters:
      `bootstrapMethods` - the array of bootstrap methods

  - ### toString

    public final String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation.